export declare type ServiceMethod = {
    name: string;
    requestType: string;
    responseType: string;
    requestStream?: boolean;
    responseStream?: boolean;
};
export declare type PackageService = {
    name: string;
    methods: ServiceMethod[];
};
export declare type Package = {
    name: string;
    services: PackageService[];
};
export declare type PackageDefinition = {
    files: string[];
    packages: Package[];
};
export declare function loadPackageDefinition(protoFile: string): Promise<PackageDefinition>;
export declare function generateStaticObjects(protoFiles: string[]): Promise<string>;
export declare function generateStaticDeclarations(staticObjectsFile: string): Promise<string>;
