"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateStaticDeclarations = exports.generateStaticObjects = exports.loadPackageDefinition = void 0;
const minimal_1 = __importDefault(require("protobufjs/minimal"));
const cli_1 = __importDefault(require("protobufjs/cli"));
const utils = __importStar(require("./utils"));
function hasNested(target) {
    return !!Object.keys(target).find((key) => key === 'nested');
}
function mapPackageServices(packageServices) {
    return utils.getObjectKeys(packageServices).reduce((services, key) => {
        if (packageServices[key].methods) {
            services.push({
                name: String(key),
                methods: mapServiceMethods(packageServices[key].methods),
            });
        }
        return services;
    }, []).sort((a, b) => strcmp(a.name, b.name));
}
function mapServiceMethods(methods) {
    return utils.getObjectKeys(methods).map((method) => ({
        name: String(method),
        requestType: methods[method].requestType,
        responseType: methods[method].responseType,
        requestStream: methods[method].requestStream,
        responseStream: methods[method].responseStream,
    })).sort((a, b) => strcmp(a.name, b.name));
}
function loadPackageDefinition(protoFile) {
    return new Promise((resolve, reject) => {
        minimal_1.default.load(protoFile, (error, output) => {
            if (output && !error) {
                const packageDefinition = {
                    files: output.files,
                    packages: output.nestedArray.map((reflectionObject) => {
                        const packageNested = hasNested(reflectionObject) ? reflectionObject.nested : {};
                        return {
                            name: reflectionObject.name,
                            services: mapPackageServices(packageNested),
                        };
                    }),
                };
                resolve(packageDefinition);
            }
            reject(error);
        });
    });
}
exports.loadPackageDefinition = loadPackageDefinition;
function strcmp(a, b) {
    if (a < b) {
        return -1;
    }
    else if (a > b) {
        return 1;
    }
    else {
        return 0;
    }
}
function generateStaticObjects(protoFiles) {
    return new Promise((resolve, reject) => {
        cli_1.default.pbjs.main([
            '--target',
            'static-module',
            '--wrap',
            'commonjs',
            '--sparse',
            '--no-create',
            '--no-verify',
            '--no-convert',
            '--no-delimited',
            '--keep-case',
            ...protoFiles,
        ], (error, output) => {
            if (error || !output) {
                reject(error || new Error('Empty output'));
                return;
            }
            resolve(output);
        });
    });
}
exports.generateStaticObjects = generateStaticObjects;
function generateStaticDeclarations(staticObjectsFile) {
    return new Promise((resolve, reject) => {
        cli_1.default.pbts.main([staticObjectsFile], (error, output) => {
            if (error || !output) {
                reject(error || new Error('Empty output'));
                return;
            }
            resolve(output);
        });
    });
}
exports.generateStaticDeclarations = generateStaticDeclarations;
